git-mergetool--lib.sh 7.25 KB
Newer Older
1
# git-mergetool--lib is a shell library for common merge tool functions
2 3

: ${MERGE_TOOLS_DIR=$(git --exec-path)/mergetools}
4

5 6 7
IFS='
'

8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24
mode_ok () {
	if diff_mode
	then
		can_diff
	elif merge_mode
	then
		can_merge
	else
		false
	fi
}

is_available () {
	merge_tool_path=$(translate_merge_tool_path "$1") &&
	type "$merge_tool_path" >/dev/null 2>&1
}

25 26 27 28 29 30 31 32 33 34 35 36 37 38
list_config_tools () {
	section=$1
	line_prefix=${2:-}

	git config --get-regexp $section'\..*\.cmd' |
	while read -r key value
	do
		toolname=${key#$section.}
		toolname=${toolname%.cmd}

		printf "%s%s\n" "$line_prefix" "$toolname"
	done
}

39 40 41
show_tool_names () {
	condition=${1:-true} per_line_prefix=${2:-} preamble=${3:-}
	not_found_msg=${4:-}
42
	extra_content=${5:-}
43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60

	shown_any=
	( cd "$MERGE_TOOLS_DIR" && ls ) | {
		while read toolname
		do
			if setup_tool "$toolname" 2>/dev/null &&
				(eval "$condition" "$toolname")
			then
				if test -n "$preamble"
				then
					printf "%s\n" "$preamble"
					preamble=
				fi
				shown_any=yes
				printf "%s%s\n" "$per_line_prefix" "$toolname"
			fi
		done

61 62 63 64 65 66 67 68 69 70 71 72 73
		if test -n "$extra_content"
		then
			if test -n "$preamble"
			then
				# Note: no '\n' here since we don't want a
				# blank line if there is no initial content.
				printf "%s" "$preamble"
				preamble=
			fi
			shown_any=yes
			printf "\n%s\n" "$extra_content"
		fi

74 75 76 77 78 79 80 81 82
		if test -n "$preamble" && test -n "$not_found_msg"
		then
			printf "%s\n" "$not_found_msg"
		fi

		test -n "$shown_any"
	}
}

83 84 85 86 87 88 89 90 91
diff_mode() {
	test "$TOOL_MODE" = diff
}

merge_mode() {
	test "$TOOL_MODE" = merge
}

translate_merge_tool_path () {
92
	echo "$1"
93 94 95
}

check_unchanged () {
96 97
	if test "$MERGED" -nt "$BACKUP"
	then
98
		return 0
99
	else
100 101
		while true
		do
102 103
			echo "$MERGED seems unchanged."
			printf "Was the merge successful? [y/n] "
104
			read answer || return 1
105
			case "$answer" in
106 107
			y*|Y*) return 0 ;;
			n*|N*) return 1 ;;
108 109 110 111 112 113
			esac
		done
	fi
}

valid_tool () {
114 115 116
	setup_tool "$1" && return 0
	cmd=$(get_merge_tool_cmd "$1")
	test -n "$cmd"
117 118
}

119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140
setup_user_tool () {
	merge_tool_cmd=$(get_merge_tool_cmd "$tool")
	test -n "$merge_tool_cmd" || return 1

	diff_cmd () {
		( eval $merge_tool_cmd )
	}

	merge_cmd () {
		trust_exit_code=$(git config --bool \
			"mergetool.$1.trustExitCode" || echo false)
		if test "$trust_exit_code" = "false"
		then
			touch "$BACKUP"
			( eval $merge_tool_cmd )
			check_unchanged
		else
			( eval $merge_tool_cmd )
		fi
	}
}

141
setup_tool () {
142 143
	tool="$1"

Ondřej Bílka's avatar
Ondřej Bílka committed
144
	# Fallback definitions, to be overridden by tools.
145 146 147 148 149 150 151 152 153
	can_merge () {
		return 0
	}

	can_diff () {
		return 0
	}

	diff_cmd () {
154
		return 1
155 156 157
	}

	merge_cmd () {
158
		return 1
159
	}
160

161 162 163 164 165
	translate_merge_tool_path () {
		echo "$1"
	}

	if ! test -f "$MERGE_TOOLS_DIR/$tool"
166
	then
167 168
		setup_user_tool
		return $?
169 170 171
	fi

	# Load the redefined functions
172
	. "$MERGE_TOOLS_DIR/$tool"
173 174 175
	# Now let the user override the default command for the tool.  If
	# they have not done so then this will return 1 which we ignore.
	setup_user_tool
176 177 178 179

	if merge_mode && ! can_merge
	then
		echo "error: '$tool' can not be used to resolve merges" >&2
180
		return 1
181 182 183
	elif diff_mode && ! can_diff
	then
		echo "error: '$tool' can only be used to resolve merges" >&2
184
		return 1
185 186
	fi
	return 0
187 188 189
}

get_merge_tool_cmd () {
190
	merge_tool="$1"
191 192
	if diff_mode
	then
193 194
		git config "difftool.$merge_tool.cmd" ||
		git config "mergetool.$merge_tool.cmd"
195
	else
196
		git config "mergetool.$merge_tool.cmd"
197
	fi
198 199
}

200
# Entry point for running tools
201
run_merge_tool () {
202 203 204 205 206
	# If GIT_PREFIX is empty then we cannot use it in tools
	# that expect to be able to chdir() to its value.
	GIT_PREFIX=${GIT_PREFIX:-.}
	export GIT_PREFIX

207
	merge_tool_path=$(get_merge_tool_path "$1") || exit
208 209
	base_present="$2"

210
	# Bring tool-specific functions into scope
211
	setup_tool "$1" || return 1
212 213 214

	if merge_mode
	then
215
		run_merge_cmd "$1"
216
	else
217
		run_diff_cmd "$1"
218
	fi
219 220
}

221 222
# Run a either a configured or built-in diff tool
run_diff_cmd () {
223
	diff_cmd "$1"
224 225 226 227
}

# Run a either a configured or built-in merge tool
run_merge_cmd () {
228
	merge_cmd "$1"
229 230
}

231
list_merge_tool_candidates () {
232 233
	if merge_mode
	then
234 235 236 237
		tools="tortoisemerge"
	else
		tools="kompare"
	fi
238 239 240 241
	if test -n "$DISPLAY"
	then
		if test -n "$GNOME_DESKTOP_SESSION_ID"
		then
242 243 244 245
			tools="meld opendiff kdiff3 tkdiff xxdiff $tools"
		else
			tools="opendiff kdiff3 tkdiff xxdiff meld $tools"
		fi
246
		tools="$tools gvimdiff diffuse diffmerge ecmerge"
Junio C Hamano's avatar
Junio C Hamano committed
247
		tools="$tools p4merge araxis bc codecompare"
248
	fi
249 250
	case "${VISUAL:-$EDITOR}" in
	*vim*)
251
		tools="$tools vimdiff emerge"
252 253
		;;
	*)
254
		tools="$tools emerge vimdiff"
255 256
		;;
	esac
257 258
}

259
show_tool_help () {
260
	tool_opt="'git ${TOOL_MODE}tool --tool=<tool>'"
261

262 263 264 265
	tab='	'
	LF='
'
	any_shown=no
266 267

	cmd_name=${TOOL_MODE}tool
268 269 270 271 272 273 274 275 276 277
	config_tools=$({
		diff_mode && list_config_tools difftool "$tab$tab"
		list_config_tools mergetool "$tab$tab"
	} | sort)
	extra_content=
	if test -n "$config_tools"
	then
		extra_content="${tab}user-defined:${LF}$config_tools"
	fi

278 279
	show_tool_names 'mode_ok && is_available' "$tab$tab" \
		"$tool_opt may be set to one of the following:" \
280 281
		"No suitable tool for 'git $cmd_name --tool=<tool>' found." \
		"$extra_content" &&
282 283 284 285 286 287 288
		any_shown=yes

	show_tool_names 'mode_ok && ! is_available' "$tab$tab" \
		"${LF}The following tools are valid, but not currently available:" &&
		any_shown=yes

	if test "$any_shown" = yes
289 290 291 292 293 294 295 296
	then
		echo
		echo "Some of the tools listed above only work in a windowed"
		echo "environment. If run in a terminal-only session, they will fail."
	fi
	exit 0
}

297 298
guess_merge_tool () {
	list_merge_tool_candidates
299 300 301 302 303 304 305
	cat >&2 <<-EOF

	This message is displayed because '$TOOL_MODE.tool' is not configured.
	See 'git ${TOOL_MODE}tool --tool-help' or 'git help config' for more details.
	'git ${TOOL_MODE}tool' will now attempt to use one of the following tools:
	$tools
	EOF
306 307

	# Loop over each candidate and stop when a valid merge tool is found.
308
	for tool in $tools
309
	do
310
		is_available "$tool" && echo "$tool" && return 0
311 312
	done

313
	echo >&2 "No known ${TOOL_MODE} tool is available."
314
	return 1
315 316 317 318 319
}

get_configured_merge_tool () {
	# Diff mode first tries diff.tool and falls back to merge.tool.
	# Merge mode only checks merge.tool
320 321
	if diff_mode
	then
322 323 324
		merge_tool=$(git config diff.tool || git config merge.tool)
	else
		merge_tool=$(git config merge.tool)
325
	fi
326 327
	if test -n "$merge_tool" && ! valid_tool "$merge_tool"
	then
328 329 330 331
		echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
		echo >&2 "Resetting to default..."
		return 1
	fi
332
	echo "$merge_tool"
333 334 335 336
}

get_merge_tool_path () {
	# A merge tool has been set, so verify that it's valid.
337
	merge_tool="$1"
338 339
	if ! valid_tool "$merge_tool"
	then
340 341 342
		echo >&2 "Unknown merge tool $merge_tool"
		exit 1
	fi
343 344
	if diff_mode
	then
345
		merge_tool_path=$(git config difftool."$merge_tool".path ||
346
				  git config mergetool."$merge_tool".path)
347 348
	else
		merge_tool_path=$(git config mergetool."$merge_tool".path)
349
	fi
350 351
	if test -z "$merge_tool_path"
	then
352
		merge_tool_path=$(translate_merge_tool_path "$merge_tool")
353
	fi
354
	if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
355 356
		! type "$merge_tool_path" >/dev/null 2>&1
	then
357
		echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
358
			 "'$merge_tool_path'"
359 360 361 362 363 364 365
		exit 1
	fi
	echo "$merge_tool_path"
}

get_merge_tool () {
	# Check if a merge tool has been configured
366
	merge_tool=$(get_configured_merge_tool)
367
	# Try to guess an appropriate merge tool if no tool has been set.
368 369
	if test -z "$merge_tool"
	then
370
		merge_tool=$(guess_merge_tool) || exit
371 372 373
	fi
	echo "$merge_tool"
}